#include <string.h>

#include <stdio.h>

static int partition( unsigned char *a, int l, int r) {
   unsigned char pivot, t;
   int i, j;
   pivot = a[l];
   i = l; j = r+1;
        
   while( 1)
   {
    do ++i; while( a[i] <= pivot && i <= r );
    do --j; while( a[j] > pivot );
    if( i >= j ) break;
    t = a[i]; a[i] = a[j]; a[j] = t;
   }
   t = a[l]; a[l] = a[j]; a[j] = t;
   return j;
}




void sort( unsigned char *a, int l, int r)
{
   int j;

   if( l < r ) 
   {
    // divide and conquer
        j = partition( a, l, r);
       sort( a, l, j-1);
       sort( a, j+1, r);
   }
    
}

static void _sort(unsigned char *a, size_t array_size)
{
     size_t i;
     for (i = 0; i < array_size - 1; ++i)
     {
          size_t j;
          unsigned char min, temp;
          min = i;
          for (j = i+1; j < array_size; ++j)
          {
               if (a[j] < a[min])
                    min = j;
          }

          temp = a[i];
          a[i] = a[min];
          a[min] = temp;
     }
}

#ifdef _TEST

 void main() 
{
    unsigned char a[256] = { 0x0a, 0xc6, 0x63, 0x10, 0x0e, 0x81, 0x8a, 0xa8, 0x74, 0x3c, 0xe8, 0x0a, 0xe4, 0x15, 0xac, 0xf2, 0x71, 0xc0, 0x69, 0x38, 0x60, 0xc8, 0x40, 0x1d, 0xc5, 0x05, 0x8e, 0xcb, 0xc0, 0x07, 0x03, 0x8b, 0x11, 0x06, 0x0d, 0x07, 0x42, 0xc0, 0x02, 0x3c, 0x09, 0x23, 0x3c, 0x91, 0x20, 0x18, 0x35, 0x0e, 0x1c, 0x07, 0x92, 0x60, 0xe0, 0x51, 0x5e, 0x03, 0x35, 0x1c, 0x3d, 0xc1, 0x17, 0xb4, 0x8e, 0x08};

    int i;
    printf("\n\nUnsorted array is:  ");
    for(i = 0; i < sizeof(a); ++i)
        printf(" %d ", a[i]);

    sort( a, 0, sizeof(a));

    printf("\n\nSorted array is:  ");
    for(i = 0; i < sizeof(a); ++i)
        printf(" %d ", a[i]);

}
#endif
